@REM ############################################################ {COPYRIGHT-TOP} ###
@REM # IBM Confidential
@REM # OCO Source Materials
@REM # Tivoli Common Reporting Infrastructure
@REM # 5724-T69
@REM #
@REM # Copyright IBM Corp. 2011
@REM #
@REM # The source code for this program is not published or otherwise
@REM # divested of its trade secrets, irrespective of what has been
@REM # deposited with the U.S. Copyright Office.
@REM ############################################################ {COPYRIGHT-END} ##
@echo off
setlocal
set PATH=%SystemRoot%\System32;%SystemRoot%;%SystemRoot%\system32\wbem;%PATH%
set DEFAULT_INSTALLATION_DIR=C:\IBM\tivoli\tipv2Components\TCRComponent
set LOGFILE=%temp%\IBM_Tivoli_Common_Reporting_2.1.1_InterimFix_2.log
set ERROR=0

echo ----------------------------------------------------------------
echo IBM Tivoli Common Reporting 2.1.1.0 InterimFix 2
echo ----------------------------------------------------------------

if "%1" == "-i" set DO=update
if "%1" == "-r" set DO=undo
set TCRCOMP_HOME=%2

if "%DO%" == "" (
   call :USAGE
   set ERROR=1
   goto :END
)

echo TCR_HOME is: %TCRCOMP_HOME%
@REM if "%TCRCOMP_HOME%" == "" (
if %TCRCOMP_HOME% == "" (
   call :USAGE
   set ERROR=1
   goto :END
)

pushd %TCRCOMP_HOME%
set TIP_HOME=%cd%
cd ..
cd ..
cd tipv2
set TIP_HOME=%cd%
echo TIP_HOME is:%TIP_HOME%
popd


@REM #######################################################################
@REM ### %ProgramFiles% serves for all flavours of OS paths used for DE installations ###
@REM #######################################################################
@echo Setting up Deployment Engine environment.
set ProgRoot=%ProgramFiles%
if not "%ProgramFiles(x86)%" == "" set ProgRoot=%ProgramFiles(x86)%
call "%ProgRoot%\IBM\Common\acsi\setenv.cmd"

@echo off
for /f "tokens=1*" %%i in ('sc query state^= all ^| find "IBMWAS70Service"') do (
   for /f "tokens=*" %%k in ('sc qc "%%j" ^| find "%TIP_HOME%\bin\wasservice.exe"') do (
     sc query "%%j" | find "RUNNING" 1>nul 2>&1
      if NOT ERRORLEVEL 1 (
         if "%DO%" == "update" (
            @echo Stop Tivoli Common Reporting server before installing InterimFix.
         ) else (
            @echo Stop Tivoli Common Reporting server before uninstalling InterimFix.
         )
         goto :END
      )
   )
)

if "%DO%" == "update" (
   set OPTIONS=-u true
   @echo Installing TCR-2110-0002...
) else (
   @echo Uninstalling TCR-2110-0002...
)
pushd %~dp0\TCR-2110-0002\META-INF
call manageIU.bat -o %DO% -r %TCRCOMP_HOME% -p packagedIU.xml %OPTIONS% 1>>"%LOGFILE%" 2>&1

if ERRORLEVEL 1 (
   if "%DO%" == "update" (
      @echo InterimFix installation failed.
   ) else (
      @echo InterimFix uninstallation failed.
   )
   @echo Check details in %LOGFILE%
   set ERROR=3
)
popd

if %ERROR% == 0 (
   if "%DO%" == "update" (
      @echo InterimFix installed successfully.
   ) else (
      @echo InterimFix uninstalled successfully.
   )
   @echo Now start Tivoli Common Reporting server.
)

:END
   endlocal
   exit /b %ERROR%

:USAGE
   echo Usage:  %~n0 -i ^| -r [TCR_INSTALLATION_DIR]
   echo.
   echo where:
   echo   -i        Install InterimFix.
   echo   -r        Rollback (uninstall) InterimFix.
   echo   [TCR_INSTALLATION_DIR] (example: %DEFAULT_INSTALLATION_DIR%)
   echo.
